import 'dart:math';

import 'package:kenken/kenken.dart';
import 'package:test/test.dart';

void main() {
  group('Function tests', () {
    test('isUniq', () {
      expect(isUniq([1, 2, 3]).value, equals(true));
      expect(isUniq([1, 2, 1]).value, equals(false));
      expect(isUniq([1, 2, 2]).value, equals(false));
      expect(
          isUniq([
            1,
            2,
          ]).value,
          equals(true));
      expect(
          isUniq([
            1,
          ]).value,
          equals(true));
    });
  });

  group('Kenken tests', () {
    Kenken kenken;

    setUp(() {
      kenken = Kenken(3);
      var values = [
        [1, 2, 3], // row = 1,
        [22, 33, 11], // row = 2,
        [333, 111, 222], // row = 3,
      ];
      // Fill kenken cells with values:
      for (var rowInd in List.generate(kenken.size, (i) => i)) {
        var row = rowInd+1;
        for (var colInd in List.generate(kenken.size, (i) => i)) {
          var col = colInd+1;
          kenken.setCell(row, col, values[rowInd][colInd]);
        }
      }

      print('kenken cells: ${kenken.cells}');

      kenken.rules = [
        //   // each row hould be uniq:
        Rule([RC(1, 1), RC(1, 2), RC(1, 3)], Operation('uniq', isUniq),
            OperationResult(true)),
        Rule([RC(2, 1), RC(2, 2), RC(2, 3)], Operation('uniq', isUniq),
            OperationResult(true)),
        Rule([RC(3, 1), RC(3, 2), RC(3, 3)], Operation('uniq', isUniq),
            OperationResult(true)),

        // each column should be uniq:
        Rule([RC(1, 1), RC(2, 1), RC(3, 1)], Operation('uniq', isUniq),
            OperationResult(true)),
        Rule([RC(1, 2), RC(2, 2), RC(3, 2)], Operation('uniq', isUniq),
            OperationResult(true)),
        Rule([RC(1, 3), RC(2, 3), RC(3, 3)], Operation('uniq', isUniq),
            OperationResult(true)),
      ];
    });

    test('row and col coordinates',(){
      var row2Coordinates = kenken.coordinatesOfRow(2);
      print('row2Coordinates: $row2Coordinates');
      // first coordinate of row2Coordinates:
      expect(row2Coordinates[0].row,equals(2));
      expect(row2Coordinates[0].col,equals(1));
      // third coordinate of row2Coordinates:
      expect(row2Coordinates[2].row,equals(2));
      expect(row2Coordinates[2].col,equals(3));
    });

    test('First Test', () {
      // expect(awesome.isAwesome, isTrue);
      print('invalid: ${kenken.invalidRules}');
      expect(kenken.invalidRules, equals([]));
    });
  });
}
